Developer Documentation

Public Member Functions | Protected Member Functions | Friends | List of all members
LightObject Class Reference
Inheritance diagram for LightObject:

## Public Member Functions
| LightObject ()
| constructor More...
| LightObject (const LightObject &_object)
| copy constructor More...
virtual | ~LightObject ()
| destructor More...
virtual void | cleanup ()
| Reset current object, including all related nodes. More...
BaseObject * | copy ()
virtual void | visible (bool _visible)
| Show Light Node.
virtual bool | visible ()
| Show Light Node.
virtual void | show ()
| Show Light Node.
virtual void | hide ()
| Hide Light Node.
Name and Path handling
void | setName (QString _name)
| Set the name of the Object. More...
Object Information
QString | getObjectinfo ()
| Get all Info for the Object as a string. More...
Picking
bool | picked (uint _node_idx)
| detect if the node has been picked More...
void | enablePicking (bool _enable)
| Enable or disable picking for this Object.
bool | pickingEnabled ()
| Check if picking is enabled for this Object.
Public Member Functions inherited from BaseObjectData
| BaseObjectData (const BaseObjectData &_object)
| copy constructor More...
| BaseObjectData ()
| constructor
virtual | ~BaseObjectData ()
| destructor
virtual ACG::Vec3d | refinePick (ACG::SceneGraph::PickTarget _pickTarget, const ACG::Vec3d _hitPoint, const ACG::Vec3d _start, const ACG::Vec3d _dir, const unsigned int _targetIdx)
| Refine picking. More...
SeparatorNode * | baseNode ()
virtual BaseNode * | primaryNode ()
QtTranslationManipulatorNode * | manipulatorNode ()
virtual ACG::SceneGraph::ShaderNode * | shaderNode ()
MaterialNode * | materialNode ()
| get a pointer to the materialnode
const MaterialNode * | materialNode () const
| get a const pointer to the materialnode
BoundingBoxNode * | boundingBoxNode ()
| get a pointer to the bounding box node
StencilRefNode * | stencilRefNode ()
| get a pointer to the stencil reference node
bool | manipPlaced ()
| Check if the manipulator has been placed.
void | manipPlaced (bool _placed)
| set the manipulator place status
void | getBoundingBox (ACG::Vec3d &bbmin, ACG::Vec3d &bbmax)
| get the bounding box of the object
void | setObjectDrawMode (const ACG::SceneGraph::DrawModes::DrawMode &_mode, const bool &_force=false)
| Set the draw mode for the object. More...
template<typename NodeT >
bool | addAdditionalNode (NodeT *_node, QString _pluginName, QString _nodeName, int _id=0)
| add an additional node to the object More...
bool | hasAdditionalNode (QString _pluginName, QString _nodeName, int _id=0)
| check if an object has the additional node More...
template<typename NodeT >
bool | getAdditionalNode (NodeT *&_node, QString _pluginName, QString _nodeName, int _id=0)
| get an addition node from the object More...
template<typename NodeT >
bool | removeAdditionalNode (NodeT *&_node, QString _pluginName, QString _nodeName, int _id=0)
| remove an additional node from the object More...
Public Member Functions inherited from BaseObject
| BaseObject (const BaseObject &_object)
| BaseObject (BaseObject *_parent=0)
virtual void | printObjectInfo ()
| Print all information about the object.
void | dumpTree ()
| Debugging function, writing the subtree to output.
int | row () const
| get the row of this item from the parent
BaseObject * | parent ()
| Get the parent item ( 0 if rootitem )
const BaseObject * | parent () const
| get the row of this item from the parent
void | setParent (BaseObject *_parent)
| Set the parent pointer.
BaseObject * | childExists (int _objectId)
| Check if the element exists in the subtree of this element.
BaseObject * | childExists (QString _name)
| Check if the element exists in the subtree of this element.
void | appendChild (BaseObject *child)
| add a child to this node
BaseObject * | child (int row)
| return a child
int | childCount () const
| get the number of children
void | removeChild (BaseObject *_item)
| Remove a child from this object.
QList< BaseObject *> | getLeafs ()
| get all leafes of the tree below this object ( These will be all visible objects )
void | deleteSubtree ()
| delete the whole subtree below this item ( The item itself is not touched )
int | group () const
bool | isGroup () const
| Check if object is a group.
bool | isInGroup (int _id) const
bool | isInGroup (QString _name) const
std::vector< int > | getGroupIds ()
QStringList | getGroupNames ()
void | setObjectData (QString _dataName, PerObjectData *_data)
void | clearObjectData (QString _dataName)
| Clear the object data pointer ( this will not delete the object!! )
bool | hasObjectData (QString _dataName)
| Checks if object data with given name is available.
PerObjectData * | objectData (QString _dataName)
| Returns the object data pointer.
void | deleteData ()
| Delete all data attached to this object ( calls delete on each object )
int | id () const
int | persistentId () const
void | persistentId (int _id)
bool | dataType (DataType _type) const
DataType | dataType () const
void | setDataType (DataType _type)
bool | target ()
void | target (bool _target)
bool | source ()
void | source (bool _source)
bool | flag (QString _flag)
void | setFlag (QString _flag, bool _set)
QStringList | flags ()
BaseObject * | last ()
BaseObject * | next ()
int | level ()
void | setFromFileName (const QString &_filename)
QString | path () const
| return the path to the object ( defaults to "." if unset )
void | setPath (const QString &_path)
| set the path to the object.
QString | name () const
| return the name of the object. The name defaults to NONAME if unset.
QString | filename () const
| return the filename of the object
void | setFileName (const QString &_filename)
| set the filename for this object
QMap< QString, PerObjectData * > & | getPerObjectDataMap ()
| get reference to map of all perObject Datas More...
QString & | getCommentByKey (const QString &key)
| Get comment for the specified key. More...
const QString | getCommentByKey (const QString &key) const
| Get comment for the specified key. More...
bool | hasCommentForKey (const QString &key) const
bool | hasComments () const
void | clearComment (const QString &key)
| Get comment for the specified key. More...
void | clearAllComments ()
| Get comment for the specified key. More...
const QMap< QString, QString > & | getAllComments () const
const QString | getAllCommentsFlat () const

## Protected Member Functions
virtual void | init (LightNode *_light=0, LightNode *_lightVis=0)
| Initialize current object, including all related nodes. More...
Update handling
This is mostly private. Updates have to be triggered via emit updatedObject()
virtual void | update (UpdateType _type=UPDATE_ALL)
| Update the Light Object. More...
Update handling
Update handling

## Friends
class | TypeLightPlugin
class | LightWidget

## Contents
LightSource | lightSource_
bool | defaultLightSource_
LightSource * | lightSource ()
bool | defaultLight () const
| Is light default light source?
void | defaultLight (const bool _default)
| Set light object to be default light.

## Visualization
LightNode * | lightNode_
| Light status node.
LightNode * | lightNodeVis_
| Light rendering node (only for rendering purposes)
LightNode * | lightNode ()
| Get the scenegraph Node.
LightNode * | lightNodeVis ()
| Get the scenegraph Node.
virtual bool | hasNode (BaseNode *_node)
| Light status node.

## Additional Inherited Members
Signals inherited from BaseObject
void | objectSelectionChanged (int _objectId)
void | visibilityChanged (int _objectId)
void | objectPropertiesChanged (int _objectId)
Static Public Attributes inherited from BaseObject
static int | NOOBJECT = -1
Protected Attributes inherited from BaseObject
bool | visible_

## Detailed Description

Definition at line 72 of file LightObject.hh.

## Constructor & Destructor Documentation

## ◆ LightObject() [1/2]

LightObject::LightObject | ( |  | ) |

constructor

Constructor for Light Objects. You dont need to create an object of this type manually.

Definition at line 111 of file LightObject.cc.

## ◆ LightObject() [2/2]

LightObject::LightObject | ( | const LightObject & | _object | ) |

copy constructor

Create a copy of this object

Copy Constructor - generates a copy of the given object

Definition at line 130 of file LightObject.cc.

## ◆ ~LightObject()

LightObject::~LightObject | ( |  | ) |
| virtual

destructor

Destructor for Light Objects. The destructor deletes the light and all Scenegraph nodes associated with the Light or the object.

Definition at line 143 of file LightObject.cc.

## Member Function Documentation

## ◆ cleanup()

void LightObject::cleanup | ( | void |  | ) |
| virtual

Reset current object, including all related nodes.

Cleanup Function for Light Objects. Deletes the contents of the whole object and calls LightObject::init afterwards.

Reimplemented from BaseObjectData.

Definition at line 171 of file LightObject.cc.

## ◆ copy()

BaseObject * LightObject::copy | ( |  | ) |
| virtual

return a full copy of this object ( All scenegraph nodes will be created ) but the object will not be a part of the object tree.

Generate a copy

Reimplemented from BaseObject.

Definition at line 187 of file LightObject.cc.

## ◆ getObjectinfo()

QString LightObject::getObjectinfo | ( |  | ) |
| virtual

Get all Info for the Object as a string.

Returns a string containing all information about the current object. This also includes the information provided by BaseObjectData::getObjectinfo

Returns
  String containing the object information

Reimplemented from BaseObject.

Definition at line 254 of file LightObject.cc.

## ◆ init()

void LightObject::init | ( | LightNode * | _light = `0`,
|  | LightNode * | _lightVis = `0`
| ) |  |
| protected virtual

Initialize current object, including all related nodes.

This function initializes the light object. It creates the scenegraph nodes.

Definition at line 194 of file LightObject.cc.

## ◆ lightSource()

LightSource * LightObject::lightSource | ( |  | ) |

True if light is default light source initially added to a blank scene

Definition at line 326 of file LightObject.cc.

## ◆ picked()

bool LightObject::picked | ( | uint | _node_idx | ) |
| virtual

detect if the node has been picked

Given an node index from PluginFunctions::scenegraphPick this function can be used to check if the lightNode of the object has been picked.

Parameters

  _node_idx | Index of the picked light node

Returns
  bool if the lightNode of this object is the picking target.

Reimplemented from BaseObjectData.

Definition at line 283 of file LightObject.cc.

## ◆ setName()

void LightObject::setName | ( | QString | _name | ) |
| virtual

Set the name of the Object.

Set the name of an object. All Scenegraph nodes are renamed too. It also calls BaseObjectData::setName.

Reimplemented from BaseObjectData.

Definition at line 213 of file LightObject.cc.

## ◆ update()

void LightObject::update | ( | UpdateType | _type = `UPDATE_ALL` | ) |
| protected virtual

Update the Light Object.

Updates the rendering of the light object

Reimplemented from BaseObjectData.

Definition at line 330 of file LightObject.cc.

## Member Data Documentation

## ◆ defaultLightSource_

bool LightObject::defaultLightSource_
| private

True if light is default light source initially added to a blank scene

Definition at line 134 of file LightObject.hh.

## ◆ lightSource_

LightSource LightObject::lightSource_
| private

True if light is default light source initially added to a blank scene

Definition at line 130 of file LightObject.hh.

The documentation for this class was generated from the following files:

- Type-Light/ObjectTypes/Light/LightObject.hh
- Type-Light/ObjectTypes/Light/LightObject.cc